=== modified file 'bzrlib/tests/per_workingtree/test_workingtree.py'
--- bzrlib/tests/per_workingtree/test_workingtree.py	2011-01-19 20:05:11 +0000
+++ bzrlib/tests/per_workingtree/test_workingtree.py	2011-01-25 16:48:24 +0000
@@ -924,6 +924,16 @@
             case_sensitive = True
         tree = self.make_branch_and_tree('test')
         self.assertEqual(case_sensitive, tree.case_sensitive)
+        # now we cheat, and make a file that matches the case-sensitive name
+        t = tree.bzrdir.get_workingtree_transport(None)
+        try:
+            content = tree._format.get_format_string()
+        except NotImplementedError:
+            # All-in-one formats didn't have a separate format string.
+            content = tree.bzrdir._format.get_format_string()
+        t.put_bytes(tree._format.case_sensitive_filename, content)
+        tree = tree.bzrdir.open_workingtree()
+        self.assertFalse(tree.case_sensitive)
 
     def test_all_file_ids_with_missing(self):
         tree = self.make_branch_and_tree('tree')

=== modified file 'bzrlib/workingtree.py'
--- bzrlib/workingtree.py	2011-01-19 20:04:23 +0000
+++ bzrlib/workingtree.py	2011-01-25 16:48:24 +0000
@@ -256,7 +256,7 @@
     def _detect_case_handling(self):
         wt_trans = self.bzrdir.get_workingtree_transport(None)
         try:
-            wt_trans.stat("FoRMaT")
+            wt_trans.stat(self._format.case_sensitive_filename)
         except errors.NoSuchFile:
             self.case_sensitive = True
         else:
@@ -2860,6 +2860,8 @@
 
     requires_normalized_unicode_filenames = False
 
+    case_sensitive_filename = "FoRMaT"
+
     @classmethod
     def find_format(klass, a_bzrdir):
         """Return the format for the working tree object in a_bzrdir."""
@@ -2932,6 +2934,8 @@
 
     requires_normalized_unicode_filenames = True
 
+    case_sensitive_filename = "Branch-FoRMaT"
+
     def get_format_description(self):
         """See WorkingTreeFormat.get_format_description()."""
         return "Working tree format 2"

